LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE WORK.blake_pak.ALL;

ENTITY blake_init IS
	PORT (
		clk_in : IN STD_LOGIC; 
		reset_in : IN STD_LOGIC;
		
		h_in : IN STD_LOGIC_WIDTHx8;
		s_in : IN STD_LOGIC_WIDTHx4;
		t_in : IN  STD_LOGIC_WIDTHx2;
		
		v_out : OUT STD_LOGIC_WIDTHx16
	);
END blake_init;

ARCHITECTURE blake_init_a OF blake_init IS
	
BEGIN 
	
	v_out(0)  <= h_in(0);
	v_out(1)  <= h_in(1);	
	v_out(2)  <= h_in(2);
	v_out(3)  <= h_in(3);
	v_out(4)  <= h_in(4);
	v_out(5)  <= h_in(5);	
	v_out(6)  <= h_in(6);	
	v_out(7)  <= h_in(7);
	v_out(8)  <= s_in(0) XOR C_CON_0;	
	v_out(9)  <= s_in(1) XOR C_CON_1;	
	v_out(10) <= s_in(2) XOR C_CON_2;	
	v_out(11) <= s_in(3) XOR C_CON_3;		
	v_out(12) <= t_in(0) XOR C_CON_4;	
	v_out(13) <= t_in(0) XOR C_CON_5;	
	v_out(14) <= t_in(1) XOR C_CON_6;	
	v_out(15) <= t_in(1) XOR C_CON_7;	
	
END ARCHITECTURE;
