LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;
USE work.blake_pak.ALL;

ENTITY round_1g IS
	PORT (
		clk_in : IN STD_LOGIC; 
		reset_in : IN STD_LOGIC;
		round_cnt_in : IN  NATURAL;
		round_num_in : IN  STD_LOGIC_VECTOR(2 DOWNTO 0);
		
		m_in : IN STD_LOGIC_WIDTHx16;
		v_in : IN STD_LOGIC_WIDTHx16;
		
		v_out : OUT STD_LOGIC_WIDTHx16
	);
END round_1g;

ARCHITECTURE round_1g_a OF round_1g IS
	SIGNAL	m , c , round_2 :STD_LOGIC_WIDTHx16;
	SIGNAL t1, t2, t3, t4, t5, t6, t7, t8, t9, t10, t11, t12, t13, t14: STD_LOGIC_VECTOR (WIDTHx1-1 DOWNTO 0);
	SIGNAL x1, x2, x3, x4,y1 ,y2 : NATURAL;	
BEGIN 
	
	m(0) <= m_in(m_num(round_cnt_in)(0));
	m(1) <= m_in(m_num(round_cnt_in)(1));
	m(2) <= m_in(m_num(round_cnt_in)(2));
	m(3) <= m_in(m_num(round_cnt_in)(3));
	m(4) <= m_in(m_num(round_cnt_in)(4));
	m(5) <= m_in(m_num(round_cnt_in)(5));
	m(6) <= m_in(m_num(round_cnt_in)(6));
	m(7) <= m_in(m_num(round_cnt_in)(7));
	m(8) <= m_in(m_num(round_cnt_in)(8));
	m(9) <= m_in(m_num(round_cnt_in)(9));
	m(10)<= m_in(m_num(round_cnt_in)(10));
	m(11)<= m_in(m_num(round_cnt_in)(11));
	m(12)<= m_in(m_num(round_cnt_in)(12));
	m(13)<= m_in(m_num(round_cnt_in)(13));
	m(14)<= m_in(m_num(round_cnt_in)(14));
	m(15)<= m_in(m_num(round_cnt_in)(15));
	
	c(0)<= c_con(round_cnt_in)(0);
	c(1)<= c_con(round_cnt_in)(1);
	c(2)<= c_con(round_cnt_in)(2);
	c(3)<= c_con(round_cnt_in)(3);
	c(4)<= c_con(round_cnt_in)(4); 
	c(5)<= c_con(round_cnt_in)(5);
	c(6)<= c_con(round_cnt_in)(6);
	c(7)<= c_con(round_cnt_in)(7);
	c(8)<= c_con(round_cnt_in)(8);
	c(9)<= c_con(round_cnt_in)(9);
	c(10)<= c_con(round_cnt_in)(10);
	c(11)<= c_con(round_cnt_in)(11);
	c(12)<= c_con(round_cnt_in)(12);
	c(13)<= c_con(round_cnt_in)(13);
	c(14)<= c_con(round_cnt_in)(14);
	c(15)<= c_con(round_cnt_in)(15);
 
 	PROCESS (round_num_in) --na osnovi najniza 3 bita
	BEGIN
		CASE round_num_in IS
			WHEN "000" =>	x1 <= 0 ; x2 <= 4 ; x3 <= 8 ;  x4 <= 12 ; y1 <= 0 ;  y2 <= 1 ; 
			WHEN "001" =>	x1 <= 1 ; x2 <= 5 ; x3 <= 9 ;  x4 <= 13 ; y1 <= 2 ;  y2 <= 3 ; 
			WHEN "010" =>	x1 <= 2 ; x2 <= 6 ; x3 <= 10 ; x4 <= 14 ; y1 <= 4 ;  y2 <= 5 ; 
			WHEN "011" =>	x1 <= 3 ; x2 <= 7 ; x3 <= 11 ; x4 <= 15 ; y1 <= 6 ;  y2 <= 7 ; 
			WHEN "100" =>	x1 <= 0 ; x2 <= 5 ; x3 <= 10 ; x4 <= 15 ; y1 <= 8 ;  y2 <= 9 ; 
			WHEN "101" =>	x1 <= 1 ; x2 <= 6 ; x3 <= 11 ; x4 <= 12 ; y1 <= 10 ; y2 <= 11 ;  
			WHEN "110" =>	x1 <= 2 ; x2 <= 7 ; x3 <= 8 ;  x4 <= 13 ; y1 <= 12 ; y2 <= 13 ; 
			WHEN OTHERS =>	x1 <= 3 ; x2 <= 4 ; x3 <= 9 ;  x4 <= 14 ; y1 <= 14 ; y2 <= 15 ; 
		END CASE;
	END PROCESS;
	
	
	t1 <= m(y1) XOR c(y1);
	t2 <= v_in(x2)+v_in(x1)+t1;
	t3 <= v_in(x4) XOR t2;
	t4 <= t3(ROT1-1 DOWNTO 0) & t3(WIDTHx1-1 DOWNTO ROT1);
	t5 <= v_in(x3) + t4;
	t6 <= v_in(x2) XOR t5;
	t7 <= t6(ROT2-1 DOWNTO 0) & t6(WIDTHx1-1 DOWNTO ROT2);	
	t8 <= m(y2) XOR c(y2);
	t9 <= t2 +t7 +t8 ;
	t10 <= t4 XOR t9;
	t11 <=t10(ROT3-1 DOWNTO 0) & t10(WIDTHx1-1 DOWNTO ROT3);
	t12 <= t5+t11;
	t13 <= t7 XOR t12;
	t14 <=t13(ROT4-1 DOWNTO 0) & t13(WIDTHx1-1 DOWNTO ROT4);
	
 	PROCESS (v_in, t9, t11, t12 ,t14,  x1, x2, x3, x4)
	BEGIN
		v_out	<= v_in;	
		v_out(x1) <= t9;
		v_out(x2) <= t14; 
		v_out(x3) <= t12;
		v_out(x4) <= t11;
	END PROCESS;
	
END ARCHITECTURE;
