#******************************************************************************
# Copyright (c) 2014 by School of Electrical Engineering University of Belgrade
# File              : launch.do
# Creation Date     : 12/09/2014
# Author            : Goran Ognjanovic
# Description       : Main TCL script for launching simulation
#******************************************************************************

##############################################
# Deleting all previously compiled libraries
##############################################
foreach I [glob *] {
        if { [file isdirectory $I] }  {
            file delete -force $I 
        }
}
##############################################
vlib work

vcom -explicit -93  "../RTL/PAK.vhd"
vcom -explicit -93  "../RTL/BLAKE_1G_ROUND.vhd"
vcom -explicit -93  "../RTL/BLAKE_1G_FIN.vhd"
vcom -explicit -93  "../RTL/BLAKE_1G_INIT.vhd"
vcom -explicit -93  "../RTL/BLAKE_1G_CONTROL.vhd"
vcom -explicit -93  "../RTL/BLAKE_1G.vhd"
vcom -explicit -93  "../TB/TESTBENCH_1G.vhd"

configure wave -gridoffset 0
configure wave -gridperiod 1
configure wave -griddelta 40

vsim -novopt -t 1ns -lib work work.TESTBENCH_1G 

do wave.do

run 10 us