LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE work.blake_pak.ALL;

ENTITY blake_control IS
	PORT (
		clk_in : IN STD_LOGIC; 
		reset_in : IN STD_LOGIC;

		inEN : IN  STD_LOGIC;
		outEN : OUT  STD_LOGIC
	);
END blake_control;

ARCHITECTURE blake_control_a OF blake_control IS
	SIGNAL enable_reg, enable_next: STD_LOGIC;
BEGIN 
	PROCESS(clk_in, reset_in)
	BEGIN
		IF (reset_in = '1') THEN
			enable_reg <= '0';
		ELSIF (clk_in'EVENT AND clk_in = '1') THEN	
			enable_reg <= enable_next;
		END IF;
	END PROCESS;

    enable_next <= inEN;
    
	outEN <= enable_reg ;

END ARCHITECTURE;