LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE work.blake_pak.ALL;

ENTITY round_8g IS
    GENERIC(
        round_cnt_in : NATURAL
    );
	PORT (
		clk_in : IN STD_LOGIC; 
		reset_in : IN STD_LOGIC;

		m_in : IN STD_LOGIC_WIDTHx16;
		v_in : IN STD_LOGIC_WIDTHx16;
		
		v_out : OUT STD_LOGIC_WIDTHx16
	);
END round_8g;




ARCHITECTURE round_8g_a OF round_8g IS
	SIGNAL	m , c , round_2 :STD_LOGIC_WIDTHx16;
	
	COMPONENT blake_g IS
		PORT (
			a : IN  STD_LOGIC_VECTOR	(WIDTHx1-1 DOWNTO 0);
			b : IN  STD_LOGIC_VECTOR	(WIDTHx1-1 DOWNTO 0);
			c : IN  STD_LOGIC_VECTOR	(WIDTHx1-1 DOWNTO 0);
			d : IN  STD_LOGIC_VECTOR	(WIDTHx1-1 DOWNTO 0);
			
			m0_in : IN  STD_LOGIC_VECTOR	(WIDTHx1-1 DOWNTO 0);
			m1_in : IN  STD_LOGIC_VECTOR	(WIDTHx1-1 DOWNTO 0);
			con0_in : IN  STD_LOGIC_VECTOR	(WIDTHx1-1 DOWNTO 0);
			con1_in : IN  STD_LOGIC_VECTOR	(WIDTHx1-1 DOWNTO 0);

			a2 : OUT  STD_LOGIC_VECTOR	(WIDTHx1-1 DOWNTO 0);
			b2 : OUT  STD_LOGIC_VECTOR	(WIDTHx1-1 DOWNTO 0);
			c2 : OUT  STD_LOGIC_VECTOR	(WIDTHx1-1 DOWNTO 0);
			d2 : OUT  STD_LOGIC_VECTOR	(WIDTHx1-1 DOWNTO 0)
		);
	END COMPONENT;	
	
BEGIN 
	
	m(0) <= m_in(m_num(round_cnt_in)(0));
	m(1) <= m_in(m_num(round_cnt_in)(1));
	m(2) <= m_in(m_num(round_cnt_in)(2));
	m(3) <= m_in(m_num(round_cnt_in)(3));
	m(4) <= m_in(m_num(round_cnt_in)(4));
	m(5) <= m_in(m_num(round_cnt_in)(5));
	m(6) <= m_in(m_num(round_cnt_in)(6));
	m(7) <= m_in(m_num(round_cnt_in)(7));
	m(8) <= m_in(m_num(round_cnt_in)(8));
	m(9) <= m_in(m_num(round_cnt_in)(9));
	m(10)<= m_in(m_num(round_cnt_in)(10));
	m(11)<= m_in(m_num(round_cnt_in)(11));
	m(12)<= m_in(m_num(round_cnt_in)(12));
	m(13)<= m_in(m_num(round_cnt_in)(13));
	m(14)<= m_in(m_num(round_cnt_in)(14));
	m(15)<= m_in(m_num(round_cnt_in)(15));
	
	c(0)<= c_con(round_cnt_in)(0);
	c(1)<= c_con(round_cnt_in)(1);
	c(2)<= c_con(round_cnt_in)(2);
	c(3)<= c_con(round_cnt_in)(3);
	c(4)<= c_con(round_cnt_in)(4); 
	c(5)<= c_con(round_cnt_in)(5);
	c(6)<= c_con(round_cnt_in)(6);
	c(7)<= c_con(round_cnt_in)(7);
	c(8)<= c_con(round_cnt_in)(8);
	c(9)<= c_con(round_cnt_in)(9);
	c(10)<= c_con(round_cnt_in)(10);
	c(11)<= c_con(round_cnt_in)(11);
	c(12)<= c_con(round_cnt_in)(12);
	c(13)<= c_con(round_cnt_in)(13);
	c(14)<= c_con(round_cnt_in)(14);
	c(15)<= c_con(round_cnt_in)(15);
 
	blake_g_com_0: blake_g 
	PORT MAP (
			a => v_in(0) ,
			b => v_in(4) ,
			c => v_in(8) ,
			d => v_in(12) ,
			
			m0_in => m(0) ,
			m1_in => m(1) ,
			con0_in => c(0) ,
			con1_in => c(1) ,

			a2 =>  round_2(0),
			b2 =>  round_2(4),
			c2 =>  round_2(8),
			d2 =>  round_2(12)
	);

	blake_g_com_1: blake_g 
	PORT MAP (
			a => v_in(1) ,
			b => v_in(5) ,
			c => v_in(9) ,
			d => v_in(13) ,
			
			m0_in => m(2) ,
			m1_in => m(3) ,
			con0_in => c(2) ,
			con1_in => c(3) ,

			a2 =>  round_2(1),
			b2 =>  round_2(5),
			c2 =>  round_2(9),
			d2 =>  round_2(13)
	);	

	blake_g_com_2: blake_g 
	PORT MAP (
			a => v_in(2) ,
			b => v_in(6) ,
			c => v_in(10) ,
			d => v_in(14) ,
			
			m0_in => m(4) ,
			m1_in => m(5) ,
			con0_in => c(4) ,
			con1_in => c(5) ,

			a2 =>  round_2(2),
			b2 =>  round_2(6),
			c2 =>  round_2(10),
			d2 =>  round_2(14)
	);


	blake_g_com_3: blake_g 
	PORT MAP (
			a => v_in(3) ,
			b => v_in(7) ,
			c => v_in(11) ,
			d => v_in(15) ,
			
			m0_in => m(6) ,
			m1_in => m(7) ,
			con0_in => c(6) ,
			con1_in => c(7) ,

			a2 =>  round_2(3),
			b2 =>  round_2(7),
			c2 =>  round_2(11),
			d2 =>  round_2(15)
	); 
 
 
	blake_g_com_4: blake_g 
	PORT MAP (
			a => round_2(0) ,
			b => round_2(5) ,
			c => round_2(10) ,
			d => round_2(15) ,
			
			m0_in => m(8) ,
			m1_in => m(9) ,
			con0_in => c(8) ,
			con1_in => c(9) ,

			a2 =>  v_out(0),
			b2 =>  v_out(5),
			c2 =>  v_out(10),
			d2 =>  v_out(15)
	);

	blake_g_com_5: blake_g 
	PORT MAP (
			a => round_2(1) ,
			b => round_2(6) ,
			c => round_2(11) ,
			d => round_2(12) ,
			
			m0_in => m(10) ,
			m1_in => m(11) ,
			con0_in => c(10) ,
			con1_in => c(11) ,

			a2 =>  v_out(1),
			b2 =>  v_out(6),
			c2 =>  v_out(11),
			d2 =>  v_out(12)
	);	

	blake_g_com_6: blake_g 
	PORT MAP (
			a => round_2(2) ,
			b => round_2(7) ,
			c => round_2(8) ,
			d => round_2(13) ,
			
			m0_in => m(12) ,
			m1_in => m(13) ,
			con0_in => c(12) ,
			con1_in => c(13) ,

			a2 =>  v_out(2),
			b2 =>  v_out(7),
			c2 =>  v_out(8),
			d2 =>  v_out(13)
	);


	blake_g_com_7: blake_g 
	PORT MAP (
			a => round_2(3) ,
			b => round_2(4) ,
			c => round_2(9) ,
			d => round_2(14) ,
			
			m0_in => m(14) ,
			m1_in => m(15) ,
			con0_in => c(14) ,
			con1_in => c(15) ,

			a2 =>  v_out(3),
			b2 =>  v_out(4),
			c2 =>  v_out(9),
			d2 =>  v_out(14)
	);

END ARCHITECTURE;