LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
--USE IEEE.NUMERIC_STD.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;
--USE IEEE.STD_LOGIC_ARITH.ALL;
--LIBRARY PAK;
USE work.blake_pak.ALL;

ENTITY blake_g IS
	PORT (
		a : IN  STD_LOGIC_VECTOR	(WIDTHx1-1 DOWNTO 0);
		b : IN  STD_LOGIC_VECTOR	(WIDTHx1-1 DOWNTO 0);
		c : IN  STD_LOGIC_VECTOR	(WIDTHx1-1 DOWNTO 0);
		d : IN  STD_LOGIC_VECTOR	(WIDTHx1-1 DOWNTO 0);
		
		m0_in : IN  STD_LOGIC_VECTOR	(WIDTHx1-1 DOWNTO 0);
		m1_in : IN  STD_LOGIC_VECTOR	(WIDTHx1-1 DOWNTO 0);
		con0_in : IN  STD_LOGIC_VECTOR	(WIDTHx1-1 DOWNTO 0);
		con1_in : IN  STD_LOGIC_VECTOR	(WIDTHx1-1 DOWNTO 0);

		a2 : OUT  STD_LOGIC_VECTOR	(WIDTHx1-1 DOWNTO 0);
		b2 : OUT  STD_LOGIC_VECTOR	(WIDTHx1-1 DOWNTO 0);
		c2 : OUT  STD_LOGIC_VECTOR	(WIDTHx1-1 DOWNTO 0);
		d2 : OUT  STD_LOGIC_VECTOR	(WIDTHx1-1 DOWNTO 0)	
		
	);
END blake_g;

ARCHITECTURE blake_g_a OF blake_g IS
	SIGNAL t1, t2, t3, t4, t5, t6, t7, t8, t9, t10, t11, t12, t13, t14 : STD_LOGIC_VECTOR (WIDTHx1-1 DOWNTO 0);
BEGIN 

	t1 <= m0_in XOR con0_in;
	t2 <= b+a+t1;
	t3 <= d XOR t2;
	t4 <= t3(ROT1-1 DOWNTO 0) & t3(WIDTHx1-1 DOWNTO ROT1);
	t5 <= c + t4;
	t6 <= b XOR t5;
	t7 <= t6(ROT2-1 DOWNTO 0) & t6(WIDTHx1-1 DOWNTO ROT2);	
	t8 <= m1_in XOR con1_in;
	t9 <= t2 +t7 +t8 ;
	t10 <= t4 XOR t9;
	t11 <=t10(ROT3-1 DOWNTO 0) & t10(WIDTHx1-1 DOWNTO ROT3);
	t12 <= t5+t11;
	t13 <= t7 XOR t12;
	t14 <=t13(ROT4-1 DOWNTO 0) & t13(WIDTHx1-1 DOWNTO ROT4);
	
	a2 <= t9;
	d2 <= t11; 
	c2 <= t12; 
	b2 <= t14;
END ARCHITECTURE;