#******************************************************************************
# Copyright (c) 2014 by School of Electrical Engineering University of Belgrade
# File              : launch.do
# Creation Date     : 12/09/2014
# Author            : Goran Ognjanovic
# Description       : Main TCL script for launching simulation
#******************************************************************************

##############################################
# Deleting all previously compiled libraries
##############################################
foreach I [glob *] {
        if { [file isdirectory $I] }  {
            file delete -force $I 
        }
}
##############################################
vlib work

vcom -explicit -93  "../RTL/PAK.vhd"
vcom -explicit -93  "../RTL/BLAKE_ROUND_G.vhd"
vcom -explicit -93  "../RTL/BLAKE_8G_ROUND.vhd"
vcom -explicit -93  "../RTL/BLAKE_112G_INIT.vhd"
vcom -explicit -93  "../RTL/BLAKE_112G_FIN.vhd"
vcom -explicit -93  "../RTL/BLAKE_112G_CONTROL.vhd"
vcom -explicit -93  "../RTL/BLAKE_112G.vhd"

vcom -explicit -93  "../TB/TESTBENCH_112G.vhd"

configure wave -gridoffset 0
configure wave -gridperiod 1
configure wave -griddelta 40

vsim -novopt -t 1ns -lib work work.TESTBENCH_112G 

do wave.do

run 10 us