LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE WORK.blake_pak.ALL;

ENTITY blake_init IS
	PORT (
		clk_in : IN STD_LOGIC; 
		reset_in : IN STD_LOGIC;
		
		h_in : IN STD_LOGIC_WIDTHx8;
		m_in : IN STD_LOGIC_WIDTHx16;
		s_in : IN STD_LOGIC_WIDTHx4;
		t_in : IN  STD_LOGIC_WIDTHx2;
		
		h_out : OUT STD_LOGIC_WIDTHx8;
		m_out : OUT STD_LOGIC_WIDTHx16;
		s_out : OUT STD_LOGIC_WIDTHx4;
		v_out : OUT STD_LOGIC_WIDTHx16
		
		
			--KOD RESENAJA SA MAX BRZINOM
			--PORUKU m DA PROSLEDJUJEMO KROZ PIPELINE ZAJEDNO SA																	
			--PODACIMA,JER CE MO U SVAKOM STEPENU CITATI TU VREDNOST
			--I m MORA BITI REGISTROVAN
	);
END blake_init;

ARCHITECTURE blake_init_a OF blake_init IS

	SIGNAL	h_reg , h_next : STD_LOGIC_WIDTHx8;
	SIGNAL	m_reg , m_next : STD_LOGIC_WIDTHx16;			
	SIGNAL	s_reg , s_next : STD_LOGIC_WIDTHx4;				
	SIGNAL	v_reg , v_next : STD_LOGIC_WIDTHx16;
	
BEGIN 
	
	PROCESS(clk_in, reset_in)
	BEGIN
		IF (reset_in = '1') THEN
			h_reg <= INIT_WIDTHx8;
			m_reg <= INIT_WIDTHx16;			
			s_reg <= INIT_WIDTHx4;			
			v_reg <= INIT_WIDTHx16;
		ELSIF (clk_in'EVENT AND clk_in = '1') THEN	
			h_reg <= h_next;
			m_reg <= m_next;			
			s_reg <= s_next;			
			v_reg <= v_next;			
		END IF;
	END PROCESS;
	
	v_next(0)  <= h_in(0);
	v_next(1)  <= h_in(1);	
	v_next(2)  <= h_in(2);
	v_next(3)  <= h_in(3);
	v_next(4)  <= h_in(4);
	v_next(5)  <= h_in(5);	
	v_next(6)  <= h_in(6);	
	v_next(7)  <= h_in(7);
	v_next(8)  <= s_in(0) XOR C_CON_0;	
	v_next(9)  <= s_in(1) XOR C_CON_1;	
	v_next(10) <= s_in(2) XOR C_CON_2;	
	v_next(11) <= s_in(3) XOR C_CON_3;		
	v_next(12) <= t_in(0) XOR C_CON_4;	
	v_next(13) <= t_in(0) XOR C_CON_5;	
	v_next(14) <= t_in(1) XOR C_CON_6;	
	v_next(15) <= t_in(1) XOR C_CON_7;	
	
	h_next <= h_in;
	m_next <= m_in;	
	s_next <= s_in;		

	h_out <= h_reg;
	m_out <= m_reg;
	s_out <= s_reg;
	v_out <= v_reg;
	
END ARCHITECTURE;
