#******************************************************************************
# Copyright (c) 2014 by School of Electrical Engineering University of Belgrade
# File              : launch.do
# Creation Date     : 12/09/2014
# Author            : Goran Ognjanovic
# Description       : Main TCL script for launching simulation
#******************************************************************************

##############################################
# Deleting all previously compiled libraries
##############################################
foreach I [glob *] {
        if { [file isdirectory $I] }  {
            file delete -force $I 
        }
}
##############################################
vlib work

vcom -explicit -93  "../RTL/PAK.vhd"
vcom -explicit -93  "../RTL/BLAKE_ROUND_G.vhd"
vcom -explicit -93  "../RTL/BLAKE_ROUND_1.vhd"
vcom -explicit -93  "../RTL/BLAKE_ROUND_2.vhd"
vcom -explicit -93  "../RTL/BLAKE_ROUND.vhd"
vcom -explicit -93  "../RTL/BLAKE_PIPE_FIN.vhd"
vcom -explicit -93  "../RTL/BLAKE_PIPE_INIT.vhd"
vcom -explicit -93  "../RTL/BLAKE_PIPE.vhd"

vcom -explicit -93  "../TB/TESTBENCH_PIPE.vhd"

#configure wave -gridoffset 500
#configure wave -gridperiod 8000
#configure wave -griddelta 10


configure wave -gridoffset 0
configure wave -gridperiod 1
configure wave -griddelta 40

vsim -novopt -t 1ns -lib work work.TESTBENCH_1G 

do wave.do

run 10 us